#include "optionsdialog.h"
#include <qdebug.h>

OptionsDialog::OptionsDialog(QWidget *parent)
    : QDialog(parent), ui_Options(new Ui::OptionsDialog)
{
    ui_Options->setupUi(this);
    connect(ui_Options->cfg_distance, SIGNAL(valueChanged(double)) ,this,SLOT(settingsChanged()));
    connect(ui_Options->cfg_ppCenterX, SIGNAL(valueChanged(int)) ,this,SLOT(settingsChanged()));
    connect(ui_Options->cfg_ppCenterY, SIGNAL(valueChanged(int)) ,this,SLOT(settingsChanged()));
    connect(ui_Options->cfg_scaling, SIGNAL(valueChanged(double)) ,this,SLOT(settingsChanged()));
    connect(ui_Options->cfg_peak1, SIGNAL(valueChanged(int)) ,this,SLOT(settingsChanged()));
    connect(ui_Options->cfg_peak2, SIGNAL(valueChanged(int)) ,this,SLOT(settingsChanged()));
    connect(ui_Options->cfg_peak3, SIGNAL(valueChanged(int)) ,this,SLOT(settingsChanged()));
    connect(ui_Options->cfg_peak4, SIGNAL(valueChanged(int)) ,this,SLOT(settingsChanged()));
    connect(ui_Options->cfg_peak5, SIGNAL(valueChanged(int)) ,this,SLOT(settingsChanged()));
    connect(ui_Options->cfg_peak6, SIGNAL(valueChanged(int)) ,this,SLOT(settingsChanged()));
    connect(ui_Options->cfg_peak7, SIGNAL(valueChanged(int)) ,this,SLOT(settingsChanged()));
    connect(ui_Options->cfg_peak8, SIGNAL(valueChanged(int)) ,this,SLOT(settingsChanged()));

    connect(ui_Options->applyButton, SIGNAL(clicked()) ,this,SLOT(settingsApply()));
    connect(ui_Options->okButton, SIGNAL(clicked()) ,this,SLOT(settingsOk()));
    connect(ui_Options->cancelButton, SIGNAL(clicked()) ,this,SLOT(settingsCancel()));

    this->setWindowTitle(QString(tr("Settings")));
}

void OptionsDialog::settingsChanged()
{
//    qDebug() << "Settings changed" << endl;
      ui_Options->changedLabel->setPixmap(QPixmap(":/icons/icons/kimproxyoffline.png"));

}

void OptionsDialog::settingsApply()
{
//    qDebug() << "Settings changed" << endl;
      ui_Options->changedLabel->setPixmap(QPixmap(":/icons/icons/kimproxyonline.png"));
      emit settingsChangedSignal(true);
}

void OptionsDialog::settingsOk()
{
//   qDebug() << "ok" << endl;

    emit settingsChangedSignal(true);
    ui_Options->changedLabel->setPixmap(QPixmap(":/icons/icons/kimproxyonline.png"));
    this->hide();
}

void OptionsDialog::settingsCancel()
{
//    qDebug() << "cancel" << endl;
    emit settingsChangedSignal(false);
}

void OptionsDialog::setImageFileName(QString filename)
{
    ui_Options->cfg_imageFileName->setText(filename);
}

void OptionsDialog::setPeaks(int *manualPeaks)
{
    qDebug() << "First Peak " << manualPeaks[0];
    (ui_Options->cfg_peak1)->setValue(manualPeaks[0]);
    ui_Options->cfg_peak2->setValue(manualPeaks[1]);
    ui_Options->cfg_peak3->setValue(manualPeaks[2]);
    ui_Options->cfg_peak4->setValue(manualPeaks[3]);
    ui_Options->cfg_peak5->setValue(manualPeaks[4]);
    ui_Options->cfg_peak6->setValue(manualPeaks[5]);
    ui_Options->cfg_peak7->setValue(manualPeaks[6]);
    ui_Options->cfg_peak8->setValue(manualPeaks[7]);
}

int * OptionsDialog::getPeaks()
{
    peaks[0] = ui_Options->cfg_peak1->value();
    peaks[1] = ui_Options->cfg_peak2->value();
    peaks[2] = ui_Options->cfg_peak3->value();
    peaks[3] = ui_Options->cfg_peak4->value();
    peaks[4] = ui_Options->cfg_peak5->value();
    peaks[5] = ui_Options->cfg_peak6->value();
    peaks[6] = ui_Options->cfg_peak7->value();
    peaks[7] = ui_Options->cfg_peak8->value();
    return peaks;
}
void OptionsDialog::setCenter(QPoint center)
{
    qDebug() << "setCenter " << center.x() << " " << center.y() << endl;
    ui_Options->cfg_ppCenterX->setValue(center.x());
    ui_Options->cfg_ppCenterY->setValue(center.y());
}

QPoint OptionsDialog::getCenter()
{
    int x = ui_Options->cfg_ppCenterX->value();
    int y = ui_Options->cfg_ppCenterY->value();
    return QPoint(x,y);
}

double OptionsDialog::getScalingFactor()
{
    return ui_Options->cfg_scaling->value();
}

void OptionsDialog::setScalingFactor(double scalingFactor)
{
    ui_Options->cfg_scaling->setValue(scalingFactor);
}

QPushButton * OptionsDialog::getSortPeaksButton()
{
    return ui_Options->sortButton;
}
