#ifndef PROJECTIONDIALOG_H
#define PROJECTIONDIALOG_H
#include "ui_ProjectionDialog.h"
#include <QPushButton>
#include <QDialog>
#include "qwt_plot_curve.h"
#include "zoomer.h"

namespace Ui
{
    class OptionsDialog;
}

class ProjectionDialog : public QDialog
{
    Q_OBJECT
public:
    ProjectionDialog(QWidget *parent = 0);
    ~ProjectionDialog();

    QwtPlot *getProjectionPlot();
    void setAverage(double average);
    void setSigma(double sigma);
    void createZoomer();
    QPushButton *getCopyButton();
    QwtPlotZoomer *m_zoomer;
    QwtPlotPicker *m_picker;

private slots:
    void enableZoom(bool on);

private:
    Ui::ProjectionDialog *ui_Projection;
    bool m_zoomEnabled;
};

#endif // PROJECTIONDIALOG_H

